Time entry creation: preserve 'spent on' value when using 'Create and Continue’
Description

When creating a time entry and using the 'Create and continue' button to save and return to the form, the previously entered date is
replaced with the current date while issue id and activity are preserved. This patch changes that so the previously entered date is
preserved as well.

Related issues:
Has duplicate Redmine - Feature #28081: Option to keep last spent-time date o... Closed

Associated revisions

Revision 17459 - 2018-08-02 08:00 - Go MAEDA

Time entry creation: preserve 'spent on' value when using 'Create and Continue' (#29308).

Patch by Jens Kramer.

Revision 17460 - 2018-08-02 10:46 - Go MAEDA
Merged r17459 from trunk to 3.4-stable (#29308).

Revision 17461 - 2018-08-02 10:59 - Go MAEDA
Merged r17459 from trunk to 3.3-stable (#29308).

History

#1 - 2018-08-01 08:22 - Go MAEDA

- Target version set to 3.3.9

| think it is very natural to preserve date and there is no reason not to do so. Probably most users expect the proposed behavior. Setting target
version to 3.3.9.

#2 - 2018-08-01 08:27 - Marius BALTEANU

Go MAEDA wrote:
| think it is very natural to preserve date and there is no reason not to do so. Probably most users expect the proposed behavior. Setting target
version to 3.3.9.

Indeed.

+1

#3 - 2018-08-01 16:13 - Go MAEDA

- Assignee set to Jens Krdmer

The patch breaks some tests. Would you update the tests?

ShowHide

Failure:

TimelogControllerTest#test_create_and_continue_at_project_level [test/functional/timelog_controller_test.rb:27

3]:

Expected response to be a redirect to <http://test.host/time_entries/new?time_entry%5Bactivity_id%5D=11l&time_e

ntry%$5Bissue_id%5D=&time_entry%$5Bproject_1id%5D=1> but was a redirect to <http://test.host/time_entries/new?tim
e_entry%5Bactivity_1d%$5D=11l&time_entry%$5Bissue_id%5D=&time_entry%$5Bproject_id%5D=1&time_entry%$5Bspent_on%5D=20
08-03-14>.

Expected "http://test.host/time_entries/new?time_entry$%$5Bactivity_id%5D=11&time_entry%5Bissue_id%5D=&time_entr
y%$5Bproject_1d%5D=1" to be === "http://test.host/time_entries/new?time_entry%$5Bactivity_id%5D=11&time_entry%5B
issue_id%5D=&¢time_entry%$5Bproject_id%5D=1&time_entry%$5Bspent_on%5D=2008-03-14".

bin/rails test test/functional/timelog_controller_test.rb:271

Failure:

TimelogControllerTest#test_create_and_continue_with_issue_id [test/functional/timelog_controller_test.rb:324]:
Expected response to be a redirect to <http://test.host/issues/1l/time_entries/new?time_entry%5Bactivity_id%5D=
llstime_entry$5Bissue_1id%5D=1&time_entry$5Bproject_id%5D=> but was a redirect to <http://test.host/issues/1l/ti
me_entries/new?time_entry%5Bactivity_id%5D=11&time_entry%5Bissue_id%5D=1&time_entry%5Bproject_id%5D=&time_entr
y%5Bspent_on%5D=2008-03-14>.

Expected "http://test.host/issues/l/time_entries/new?time_entry%5Bactivity_id%5D=11&time_entry%5Bissue_id%5D=1
&time_entry%$5Bproject_id%5D=" to be === "http://test.host/issues/l/time_entries/new?time_entry%5Bactivity_id%5
D=1l&time_entry%$5Bissue_id%5D=1&time_entry%$5Bproject_1id%5D=&time_entry%$5Bspent_on%5D=2008-03-14".

bin/rails test test/functional/timelog_controller_test.rb:322

Failure:
TimelogControllerTest#test_create_and_continue_at_issue_level [test/functional/timelog_controller_test.rb:290]

Expected response to be a redirect to <http://test.host/time_entries/new?time_entry%$5Bactivity_id%5D=11&time_e
ntry%$5Bissue_1d%5D=1&time_entry%$5Bproject_id%5D=> but was a redirect to <http://test.host/time_entries/new?tim
e_entry%$5Bactivity_id%$5D=11l&time_entry%$5Bissue_id%5D=1&time_entry%$5Bproject_id%5D=&time_entry%$5Bspent_on%$5D=20
08-03-14>.

Expected "http://test.host/time_entries/new?time_entry%$5Bactivity_id%5D=11&time_entry%$5Bissue_1id%5D=1&time_ent
ry%$5Bproject_1id%5D=" to be === "http://test.host/time_entries/new?time_entry%$5Bactivity_id%5D=11&time_entry%5B
issue_1d%5D=1l&time_entry%$5Bproject_id%5D=&time_entry%$5Bspent_on%5D=2008-03-14".

bin/rails test test/functional/timelog_controller_test.rb:288

Failure:

TimelogControllerTest#test_create_and_continue_with_project_id [test/functional/timelog_controller_test.rb:307
18

Expected response to be a redirect to <http://test.host/projects/ecookbook/time_entries/new?time_entry$5Bactiv
ity_id%5D=11&time_entry%$5Bissue_1id%5D=&time_entry%$5Bproject_1d%5D=> but was a redirect to <http://test.host/pr
ojects/ecookbook/time_entries/new?time_entry%5Bactivity_id%5D=11&time_entry%$5Bissue_id%5D=&time_entry%5Bprojec
t_id%5D=&time_entry%$5Bspent_on%5D=2008-03-14>.

Expected "http://test.host/projects/ecookbook/time_entries/new?time_entry$5Bactivity_1id%5D=11&time_entry%$5Biss
ue_id%5D=&time_entry%$5Bproject_id%5D=" to be === "http://test.host/projects/ecookbook/time_entries/new?time_en
try%$5Bactivity_id%5D=11&time_entry%$5Bissue_1id%5D=&time_entry%$5Bproject_id%5D=&time_entry%$5Bspent_on%5D=2008-03
—-14".

bin/rails test test/functional/timelog_controller_test.rb:305

#4 - 2018-08-02 05:19 - Jens Kramer

- File 0002-amends-the-timelog_controller_test-to-account-for-sp.patch added
my bad, please find attached a second patch that fixes those.

#5 - 2018-08-02 07:25 - Go MAEDA
- Assignee changed from Jens Krdmer to Go MAEDA

Great, everything is fine now. Thanks.

#6 - 2018-08-02 08:00 - Go MAEDA

- Status changed from New to Resolved

#7 - 2018-08-02 11:01 - Go MAEDA

- Status changed from Resolved to Closed
Committed. Thank you for sharing the improvement.

#8 - 2018-08-07 06:28 - Marius BALTEANU

- Has duplicate Feature #28081: Option to keep last spent-time date on "create and continue" added

Files
0001-time-entry-creation-preserve-spent-on-when-using-cre.patch 936 Bytes 2018-08-01 Jens Kramer
0002-amends-the-timelog_controller_test-to-account-for-sp.patch 2.36 KB 2018-08-02 Jens Kramer
